package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LinePreOrderExt struct {
	api.Api
}

// GetPage 获取委托拓展参数列表
// @Summary 获取委托拓展参数列表
// @Description 获取委托拓展参数列表
// @Tags 委托拓展参数
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LinePreOrderExt}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-pre-order-ext [get]
// @Security Bearer
func (e LinePreOrderExt) GetPage(c *gin.Context) {
    req := dto.LinePreOrderExtGetPageReq{}
    s := service.LinePreOrderExt{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LinePreOrderExt, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取委托拓展参数失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取委托拓展参数
// @Summary 获取委托拓展参数
// @Description 获取委托拓展参数
// @Tags 委托拓展参数
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LinePreOrderExt} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-pre-order-ext/{id} [get]
// @Security Bearer
func (e LinePreOrderExt) Get(c *gin.Context) {
	req := dto.LinePreOrderExtGetReq{}
	s := service.LinePreOrderExt{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LinePreOrderExt

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取委托拓展参数失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建委托拓展参数
// @Summary 创建委托拓展参数
// @Description 创建委托拓展参数
// @Tags 委托拓展参数
// @Accept application/json
// @Product application/json
// @Param data body dto.LinePreOrderExtInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-pre-order-ext [post]
// @Security Bearer
func (e LinePreOrderExt) Insert(c *gin.Context) {
    req := dto.LinePreOrderExtInsertReq{}
    s := service.LinePreOrderExt{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建委托拓展参数失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改委托拓展参数
// @Summary 修改委托拓展参数
// @Description 修改委托拓展参数
// @Tags 委托拓展参数
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LinePreOrderExtUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-pre-order-ext/{id} [put]
// @Security Bearer
func (e LinePreOrderExt) Update(c *gin.Context) {
    req := dto.LinePreOrderExtUpdateReq{}
    s := service.LinePreOrderExt{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改委托拓展参数失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除委托拓展参数
// @Summary 删除委托拓展参数
// @Description 删除委托拓展参数
// @Tags 委托拓展参数
// @Param data body dto.LinePreOrderExtDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-pre-order-ext [delete]
// @Security Bearer
func (e LinePreOrderExt) Delete(c *gin.Context) {
    s := service.LinePreOrderExt{}
    req := dto.LinePreOrderExtDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除委托拓展参数失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
